# coding: utf-8

"""
    Flagr

    Flagr is a feature flagging, A/B testing and dynamic configuration microservice. The base path for all the APIs is \"/api/v1\".   # noqa: E501

    OpenAPI spec version: 1.1.10
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class Flag(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'key': 'str',
        'description': 'str',
        'enabled': 'bool',
        'tags': 'list[Tag]',
        'segments': 'list[Segment]',
        'variants': 'list[Variant]',
        'data_records_enabled': 'bool',
        'entity_type': 'str',
        'notes': 'str',
        'created_by': 'str',
        'updated_by': 'str',
        'updated_at': 'datetime'
    }

    attribute_map = {
        'id': 'id',
        'key': 'key',
        'description': 'description',
        'enabled': 'enabled',
        'tags': 'tags',
        'segments': 'segments',
        'variants': 'variants',
        'data_records_enabled': 'dataRecordsEnabled',
        'entity_type': 'entityType',
        'notes': 'notes',
        'created_by': 'createdBy',
        'updated_by': 'updatedBy',
        'updated_at': 'updatedAt'
    }

    def __init__(self, id=None, key=None, description=None, enabled=None, tags=None, segments=None, variants=None, data_records_enabled=None, entity_type=None, notes=None, created_by=None, updated_by=None, updated_at=None):  # noqa: E501
        """Flag - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._key = None
        self._description = None
        self._enabled = None
        self._tags = None
        self._segments = None
        self._variants = None
        self._data_records_enabled = None
        self._entity_type = None
        self._notes = None
        self._created_by = None
        self._updated_by = None
        self._updated_at = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if key is not None:
            self.key = key
        self.description = description
        self.enabled = enabled
        if tags is not None:
            self.tags = tags
        if segments is not None:
            self.segments = segments
        if variants is not None:
            self.variants = variants
        self.data_records_enabled = data_records_enabled
        if entity_type is not None:
            self.entity_type = entity_type
        if notes is not None:
            self.notes = notes
        if created_by is not None:
            self.created_by = created_by
        if updated_by is not None:
            self.updated_by = updated_by
        if updated_at is not None:
            self.updated_at = updated_at

    @property
    def id(self):
        """Gets the id of this Flag.  # noqa: E501


        :return: The id of this Flag.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Flag.


        :param id: The id of this Flag.  # noqa: E501
        :type: int
        """
        if id is not None and id < 1:  # noqa: E501
            raise ValueError("Invalid value for `id`, must be a value greater than or equal to `1`")  # noqa: E501

        self._id = id

    @property
    def key(self):
        """Gets the key of this Flag.  # noqa: E501

        unique key representation of the flag  # noqa: E501

        :return: The key of this Flag.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this Flag.

        unique key representation of the flag  # noqa: E501

        :param key: The key of this Flag.  # noqa: E501
        :type: str
        """
        if key is not None and len(key) < 1:
            raise ValueError("Invalid value for `key`, length must be greater than or equal to `1`")  # noqa: E501

        self._key = key

    @property
    def description(self):
        """Gets the description of this Flag.  # noqa: E501


        :return: The description of this Flag.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Flag.


        :param description: The description of this Flag.  # noqa: E501
        :type: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501
        if description is not None and len(description) < 1:
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `1`")  # noqa: E501

        self._description = description

    @property
    def enabled(self):
        """Gets the enabled of this Flag.  # noqa: E501


        :return: The enabled of this Flag.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this Flag.


        :param enabled: The enabled of this Flag.  # noqa: E501
        :type: bool
        """
        if enabled is None:
            raise ValueError("Invalid value for `enabled`, must not be `None`")  # noqa: E501

        self._enabled = enabled

    @property
    def tags(self):
        """Gets the tags of this Flag.  # noqa: E501


        :return: The tags of this Flag.  # noqa: E501
        :rtype: list[Tag]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this Flag.


        :param tags: The tags of this Flag.  # noqa: E501
        :type: list[Tag]
        """

        self._tags = tags

    @property
    def segments(self):
        """Gets the segments of this Flag.  # noqa: E501


        :return: The segments of this Flag.  # noqa: E501
        :rtype: list[Segment]
        """
        return self._segments

    @segments.setter
    def segments(self, segments):
        """Sets the segments of this Flag.


        :param segments: The segments of this Flag.  # noqa: E501
        :type: list[Segment]
        """

        self._segments = segments

    @property
    def variants(self):
        """Gets the variants of this Flag.  # noqa: E501


        :return: The variants of this Flag.  # noqa: E501
        :rtype: list[Variant]
        """
        return self._variants

    @variants.setter
    def variants(self, variants):
        """Sets the variants of this Flag.


        :param variants: The variants of this Flag.  # noqa: E501
        :type: list[Variant]
        """

        self._variants = variants

    @property
    def data_records_enabled(self):
        """Gets the data_records_enabled of this Flag.  # noqa: E501

        enabled data records will get data logging in the metrics pipeline, for example, kafka.  # noqa: E501

        :return: The data_records_enabled of this Flag.  # noqa: E501
        :rtype: bool
        """
        return self._data_records_enabled

    @data_records_enabled.setter
    def data_records_enabled(self, data_records_enabled):
        """Sets the data_records_enabled of this Flag.

        enabled data records will get data logging in the metrics pipeline, for example, kafka.  # noqa: E501

        :param data_records_enabled: The data_records_enabled of this Flag.  # noqa: E501
        :type: bool
        """
        if data_records_enabled is None:
            raise ValueError("Invalid value for `data_records_enabled`, must not be `None`")  # noqa: E501

        self._data_records_enabled = data_records_enabled

    @property
    def entity_type(self):
        """Gets the entity_type of this Flag.  # noqa: E501

        it will override the entityType in the evaluation logs if it's not empty  # noqa: E501

        :return: The entity_type of this Flag.  # noqa: E501
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type):
        """Sets the entity_type of this Flag.

        it will override the entityType in the evaluation logs if it's not empty  # noqa: E501

        :param entity_type: The entity_type of this Flag.  # noqa: E501
        :type: str
        """

        self._entity_type = entity_type

    @property
    def notes(self):
        """Gets the notes of this Flag.  # noqa: E501

        flag usage details in markdown format  # noqa: E501

        :return: The notes of this Flag.  # noqa: E501
        :rtype: str
        """
        return self._notes

    @notes.setter
    def notes(self, notes):
        """Sets the notes of this Flag.

        flag usage details in markdown format  # noqa: E501

        :param notes: The notes of this Flag.  # noqa: E501
        :type: str
        """

        self._notes = notes

    @property
    def created_by(self):
        """Gets the created_by of this Flag.  # noqa: E501


        :return: The created_by of this Flag.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this Flag.


        :param created_by: The created_by of this Flag.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def updated_by(self):
        """Gets the updated_by of this Flag.  # noqa: E501


        :return: The updated_by of this Flag.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this Flag.


        :param updated_by: The updated_by of this Flag.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def updated_at(self):
        """Gets the updated_at of this Flag.  # noqa: E501


        :return: The updated_at of this Flag.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Flag.


        :param updated_at: The updated_at of this Flag.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Flag, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Flag):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
